#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/wait.h>

#define LUTIN "lutin"
#define SIZE 5
#define die(e) do { fprintf(stderr, "%s\n", e); exit(EXIT_FAILURE); } while (0);

int main() {
  int i = 0;
  int link[2];
  pid_t pid;
  char foo[4096];

  if (pipe(link)==-1)
    die("pipe");

  if ((pid = fork()) == -1)
    die("fork");

  if(pid == 0) {
    dup2 (link[1], STDOUT_FILENO);
    close(link[0]);
    close(link[1]);
    execl("/bin/ps", "ps", "-a", (char *)0);
    die("ps");
  } else {
    close(link[1]);
    int nbytes = read(link[0], foo, sizeof(foo));
    int inside = 0;
    //printf("Output: (%.*s)\n", nbytes, foo);
    for (i = 0; i < nbytes; i++) {
      if (strncmp(&foo[i], LUTIN, SIZE) == 0) {
	inside += 1;
      }
    }
    if (inside > 1) {
      puts( "" );
      puts( "Mais que faites vous assis sur un de mes frêres ?!!" );
      puts( "Ne le gardez pas ainsi en arrière plan !" );
      puts( "Vous arrêtez son processus avec la commande 'kill'," );
      puts( "puis vous le relachez avec 'fg' !" );
      puts( "En attendant, tant qu'il est en arrière plan," );
      puts( "je ne vous dirais rien." );
      puts( "" );     
     } else {
      puts( "" );
      puts( "Pas de violence ! Inutile d'utiliser SIGINT (2) ou " );
      puts( "SIGTERM (15) avec moi ! Je ne sais rien ! le lutin qui" );
      puts( "sait des choses est parti aux toilettes." );
      puts( "remontez d'un niveau, vous ne pouvez pas les louper." );
      puts( "" );     
    }
    wait(NULL);
  }
  return 0;
}
