#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>

void gestionnaire (int numero) {
  int i;
  switch (numero) {
  case SIGQUIT:
    puts("\nSIGQUIT ne peut pas me tuer");
    break;
  case SIGINT:
    puts("\nMême pas mal avec ton SIGINT... Essaye autre chose.");
    puts("Je me duplique ça te fera les pieds.");
    i = fork();
    break;
  case SIGTERM:
    puts("\nC'est tout ce que tu peux faire ? J'ai pas peur de SIGTERM. Essaye mieux.");
    puts("Je me duplique ça te fera les pieds.");
    i = fork();
    break;
  case SIGILL:
    puts("\nTu crois que ton petit SIGILL me fait peur ?");
    puts("Je me duplique ça te fera les pieds.");
    i = fork();
    break;
  case SIGHUP:
    puts("\nRien a faire de ton SIGHUP !");
    break;
  case SIGFPE:
    puts("\nQuoi SIGFPE ? J'ai tenté une opération mathématique illégale ? J'ai fais une division par zéro ! Arrgggh tu as gagné ! Lis le message que je te laisse ici.");
    FILE * ref = fopen("message", "w"); 
    fprintf(ref, "\nPour trouver mon trésor, remontez de 3 niveaux et passez par la porte dissimulée...\n");
    fclose(ref);
    exit(EXIT_SUCCESS);
    break;
  default:
    printf("\nNon le signal %d ne peut pas non plus me tuer\n", numero);
    break;
  }
}

int main (void)
{
  int SIGNAL;
  struct sigaction action;
  action.sa_handler = gestionnaire;
  sigemptyset(& (action.sa_mask));
  action.sa_flags = 0;

  for (SIGNAL = 1; SIGNAL < 32; SIGNAL++) {
    if (SIGNAL == SIGTSTP) continue;
    sigaction(SIGNAL, &action, NULL);
  }

  action.sa_flags = SA_RESTART | SA_RESETHAND;

  puts("\nTu viens de me réveiller.");
  puts("Je suis un vieux daemon et tu viens de me réveiller.");
  puts("Je suis ton pire cauchemard. Un cousin du sphinx.");
  puts("Tu ne peux même pas me tuer.");
  puts("\nSoit tu trouves la réponse à ma question soit tu combats.");
  puts("Mais si tu me tues tu ne sauras jamais où est mon trésor...");
  puts("\nQuel est le résultat de 10 divisé par (4 moins 2 au carré) ?");

  while (1) {
    int i;
    i = pause();
  }

  return EXIT_SUCCESS;
}
