#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>

void gestionnaire (int numero) {
    switch (numero) {
        case SIGINT:
	    puts("\nMmm, SIGINT (Ctrl+C), ce n'est pas très poli.");
	    puts("Je n'aime pas les signaux.");
	    puts("Tu pourrais terminer la conversation ne manière civilisée");
	    puts("qu'en penses tu ?");
            break;
        case SIGQUIT:
	    puts("\nMmm, SIGQUIT (Ctrl+\\), ce n'est pas très poli.");
	    puts("Je n'aime pas les signaux.");
	    puts("Tu pourrais terminer la conversation ne manière civilisée");
            puts("qu'en penses tu ?");
            break;
        default:
            break;
    }
}

int main (void)
{
	struct sigaction action;
	action.sa_handler = gestionnaire;
	sigemptyset(& (action.sa_mask));
	action.sa_flags = 0;

	if (sigaction (SIGINT, &action, NULL) != 0) {
		fprintf (stderr, "Erreur %d\n", errno);
		exit(EXIT_FAILURE);
	}
    
    if (sigaction (SIGQUIT, &action, NULL) != 0) {
        fprintf (stderr, "Erreur %d\n", errno);
        exit(EXIT_FAILURE);
    }

	action.sa_flags = SA_RESTART | SA_RESETHAND;

	printf ("Je suis un lutin curieux. Tu as déjà rencontré un lutin curieux ? Moi j'ai jamais rencontré d'humain, raconte moi tout !\n");

	char* buf[10];
	while(1) {
		if (read(0, buf, 10) == 0)
			break;
	}
	puts("\nMmm, c'est demandé si poliment avec Ctrl+D");
	puts("(qui transmet EOF sur la sortie standard et non un signal),");
	puts("ok, j'arrête de t'ennuyer.");

	return EXIT_SUCCESS;
}
