#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

int main () {
    int i;
    pid_t child_pid;
    /* Crée des processus fils. */
    for (i = 0; i < 10; i++) {
        child_pid = fork ();
        
        if (child_pid == 0) {
            /* Nous sommes dans le processus fils. Sortie immédiate. */
            execl("./zombie", "zombie", NULL);
            exit (0);
        }
    }
    
    /* Nous sommes dans le processus parent. Attente. */
    pause();
    
    return 0;
}
