#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/wait.h>

#define ZOMBIE "zombie"
#define SIZE 6
#define die(e) do { fprintf(stderr, "%s\n", e); exit(EXIT_FAILURE); } while (0);

int main() {
  int i = 0;
  int link[2];
  pid_t pid;
  char foo[4096];

  FILE* fichier = NULL;
  fichier = fopen(ZOMBIE,"r");
  if (fichier != NULL)
      fclose(fichier);
  else {
    system("cp ~/tp7/.proc/papa_zombies .");
    system("cp ~/tp7/.proc/zombie .");
    system("./papa_zombies &");

    puts( "" );
    puts( "Ahhh, aidez moi ! Cette cave est pleine de zombies !" );
    puts( "Tuez les tous !" );
    puts( "" );
    return 0;
  }

  if (pipe(link)==-1)
    die("pipe");

  if ((pid = fork()) == -1)
    die("fork");

  if(pid == 0) {
    dup2 (link[1], STDOUT_FILENO);
    close(link[0]);
    close(link[1]);
    execl("/bin/ps", "ps", "-a", (char *)0);
    die("ps");
  } else {
    close(link[1]);
    int nbytes = read(link[0], foo, sizeof(foo));
    int inside = 0;
    //printf("Output: (%.*s)\n", nbytes, foo);
    for (i = 0; i < nbytes; i++) {
      if (strncmp(&foo[i], ZOMBIE, SIZE) == 0) {
	inside += 1;
      }
    }
    if (inside > 1) {
      puts( "" );
      puts( "Cette cave est pleine de zombies !!! chuuuttt taisez vous" );
      puts( "Je ne dirais rien, j'ai trop peur pour ça." );
      puts( "" );
    } else {
      puts( "" );
      puts( "vous avez tué tous les zombies ??" );
      puts( "ahhh, vous êtes merveilleux !" );
      puts( "Remontez de deux niveaux et entrez dans le 'couloir_mysterieux'." );
      puts( "" );
    }
    wait(NULL);
  }
  return 0;
}
